/* PROGRAMME CODE FOR A BANKING APPLICATION PURPOSE,MORE EMPHASIS ON THE REAL TIME PROBLEMS FACED BY CUSTOMERS */
//This project consists of three user interface,an employee or a customer can work on this function//
//Any employee of the bank should know the unique id provided by bank during his/her registration//
//customer may be of 2,existing and other is new customer//
//existing customer should have his account number that's the login id and password to enter in his account//
//new coustomer can open account in the bank,or can deposit money in any account//
//he can know the policies of bank//
//he can make draft or Pay orders //
//this project works on class and files all the data of user and staff is taken and saved in a file ,this file is a txt file and //
//it can be modified as per need//
/*       ios::in	     Open for input operations.
         ios::out	     Open for output operations.
         ios::binary	 Open in binary mode.
         ios::ate	     Set the initial position at the end of the file.
                         If this flag is not set, the initial position is the beginning of the file.
         ios::app	     All output operations are performed at the end of the file, appending the content to the current content of the file.
         ios::trunc	     If the file is opened for output operations and it already existed, its previous content is deleted and replaced by the new one.*/

/*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/
//                                              HEADER    FILES                                                //
/*_____________________________________________________________________________________________________________*/

#include <iostream>         //INPUT OUTPUT stream.
#include<fstream>           //to write in DATA FILES.
#include<string>            //to work  with STRINGS.
#include<cstdio>
#include<conio.h>
#include<iomanip>
#include<cstdlib>           //c standard library.
#include<ctime>             //to use srand function for generating random account numbers.

using namespace std;

class shortbank                      ////name of class is shortbank////
{
    private:
        int idEmp;                             //id of bank staff members.
        char nameS[30];                        //name of staff members.
        char nameOfAccountHolder[30];          //name of account holders.
        char parentName[30];                   //parent/ husband name of account holders.
        long int dob;                          //date of birth of acc holders.
        char sex[10];                          //gender of acc holders.
        char tempadd[50];                      //temperory address of acc holders.
        char permadd[50];                      //permanent address of acc holders.
        char id[20];                           //what proof of id they have submitted.
        int idno;                              //number of that id proof.
        double mobileNo;                       //contact number of acc holder.
        int accountNumber;                     //account number of account holder.
        char accountType;                      //type of account savings of current.
        int bal;                               //balance in the account of customer.
        int pass;                              //password of customer.
        int pass1;                             //confirm password while registering.
        int numm;                              //


    public:
        void reg_staff();                      //for registration of new staff.
        void show_staff()const;                //to show authentication of staff.
        int return_id()const;                  //return's unique id of staff.
        int totalBankBal()const;
        void mainMenuadmin();                  //maim menu for the admin the boss.
        void mainMenu1();                      //main menu for the existing customers.
        void mainMenu2();                      //main menu for the new customers.
        void creat_acc();                      //opening  new account.
        void show_details()const;              //whowing details of a particular account.
        void allaccounts() const;
        void depositIt(int);                   //to deposit money in someone's account.
        void withdrawIt(int);                  //to withdraw money from a account.
        int returnacc()const;                  //to return account number.
        int returnbal()const;                  //to return current balance.
        int returnpass()const;                 //to return password.
        void changepassword(int);              //to change the password.
        int generateacc()const;                //to generate the random account number and draft number.
        void printacc()const;                  //to print passbook.
        int agf();                             //
        void showNameBalance()const;           //to show only name account no. and balance to a customer.
        void draft()const;                     //to make a draft.
        void modifyDetails();                  //to madify details.
        void moneyTransfer();                  //to transfer money in other bank and own bank but other account.
        char returntype()const;
        void selfdraft(int);
        };

                            //EXTERNAL FUNCTIONS.
void regStaff();                                //for registerring staff.
int login(int);                                 //for staff login.
void newCustomer();                             //for a new customer (account opening )
void customerlist();
void details(int,int);                          //for the details of an account holder.
int detailshort(int,int);                       //for short details.
void withdrawl(int);                            //to withdrawl
void deposit(int);                              //to deposit.
void printpassbook(int);                        //to printpassbook
void changePass(int);                           //to change password.
void deletecu(int);                             //to delete a customer
void otherbank();                               //for other bank transfer.
void balance(int);                              //to balance .
void editdetails(int);                          //to edit details of the account in the case of add change etc.
void otherBank(int,int);                        //other bank transfer.
void sameBankTransfer(int,int);                 //same bank transfer.
void smalldetails();                            //small details.
                            //make payment from self account.
void make_own_draft(int,int);

////MAIN FUNCTION////

int main()
{

shortbank pop;
    int choice;
    char customertype;

    int accessid,anum,password;


  //regStaff();//function used by admin to register new staff member's.// can only be opened by admin



    cout<<"\n***********************________YOUR BANK________************************";
    int z=0;
    do{

    cout<<"\n\nPRESS 1 FOR BANK EMPLOYEE OR 2 FOR CUSTOMER  ---  ";
   // cout<<"\n\n(press 1 for bank employee and 2 for customer):       ";
    cin>>choice;
    if(choice==1)
        {
            int i=0;
            do
                {
                cout<<"\n\nENTER YOUR UNIQUE ID NUMBER--- ";
                cin>>accessid;
               int vary=login(accessid);
              //  ifstream adminpass("adminpassword.txt",ios::binary);     //inFile.open("account.dat",ios::binary);
              //  adminpass>>word;
            if  (vary==1)
                {

                pop.mainMenuadmin();
                return 0;
                }
           else if (vary==2)
                {
                     cout<<"\n\n INVALID ID ";
                }

          else return 0;
           i++;

                }while(i<3);return 0;
                }
             else
              if (choice==2)
                {

                int n=0;

       do
       {

        cout<<"\n\nplease tell if you are an existing customer or not (y-yes & n-no):    ";
        cout<<"\n\notherwise press x to exit      ";
        cin>>customertype;
        if(customertype=='y'||customertype=='Y')
              {
                     int k=0;

                    do
                     {


                       cout<<"\n\nPlease enter your account number :";
                       cin>>anum;
                       cout<<"\n\nPlease enter your Password :";
                       cin>>password;

                     int var=detailshort(anum,password);
                       if(var==1)
                      {

                      pop.mainMenu1();return 0;//function for the main menu for existing customer//
                      }
                      else
                      {
                          k++;
                          if (k<2)
                                         {
                                            cout<<"\n\nplease enter a valid account number and password";continue;
                                         }
                          else break;
                      }



                               }while(k<3);cout<<"\n\nyou are not a valid coustomer";
                                   return 9;


                     }

else
            if(customertype=='n'||customertype=='N')
               {
                pop.mainMenu2();break;
               }

        else
            if(customertype=='x'||customertype=='X')
              {
                 break;
              }
        else
             {
            if (n!=2)
                  {
                   cout<<"\n\n you entered an invalid choice" ;
                   cout<<"\n\n enter a valid choice ";
                  }
            else
                  {
                    cout<<"\n\n you have entered 3 wrong choices. you are blocked for the day ,have a nice day ";
                  }
               n++;
               continue;
             }
       }
         while(n<3);
    return 8;
  }
  else if(choice!=1&&choice!=2)
  {
      if(z<2)
          cout<<"\n\nEnter a valid choice";
  }
  z++;
  }while(z<3);
   return 0;
}

int shortbank::generateacc()const
{
   long long int an;
   // cout<<10000+(rand()%20000)<<endl;
   srand(time(NULL));
    //ofstream dd;
   // dd.open("iit.txt");
   {
   an=10000+rand()%20000;
   }
    return an;
}
void shortbank::draft()const
{
    int dateOfDraft,amtOfDraft;
    char draftInFavourOf[50];
    char sigMan[15];
                cout<<"\ntodays date(ddmmyyyy)--";
                cin>>dateOfDraft;
                cout<<"\ndraft in favour of ----";
                cin.ignore();
                cin.getline(draftInFavourOf,50);
                cout<<"\namount of draft--------";
                cin>>amtOfDraft;
                cout<<"\nsignature of manager---";
                cin.ignore();
                cin.getline(sigMan,15);
                cout<<"\n\n----------------------------------------------------------------------";
                cout<<"\n\t\t\t\t YOUR BANK "<<endl;
                cout<<"\t\t\t\t\t\t\tdate-"<<dateOfDraft;
                cout<<"\ndraft in favour of--- Mr/Mrs/Miss "<<draftInFavourOf;
                cout<<"\n\t\t\t\t\t  amount--Rs."<<amtOfDraft;
                cout<<"\n\nSerial No."<<generateacc()<<"\t\t\t\t\t( "<<sigMan<<" )";
                cout<<"\n\t\t\t\t\t\t\tManager";
                cout<<"\n\n----------------------------------------------------------------------";

}

void shortbank::modifyDetails()
{

	cout<<"\nEdit Account Holder Name : ";
	cin.ignore();
	cin.getline(nameOfAccountHolder,30);
	cout<<"\nEdit Parent Name         : ";
	cin.ignore();
	cin.getline(parentName,30);
	cout<<"\nEdit temprory address    : ";
	cin.ignore();
	cin.getline(tempadd,50);
	cout<<"\nEdit permanent address   : ";
	cin.ignore();
	cin.getline(permadd,50);
	cout<<"\nEdit mobile number       : ";
	cin>>mobileNo;

}
void shortbank::mainMenu2()
{
    shortbank pop;
    int option;int num;

    do
    {
     cout<<"\n\n\tPlease select any one of the following options (1-2):";
     cout<<"\n\n\t1...open new account:";
     cout<<"\n\n\t2...make draft.";
     cout<<"\n\n\t3...deposit money in somebudies account.";
     cout<<"\n\n\t4...know our policies.";
     cout<<"\n\n\t5...exit.";
     cout<<"\nYOUR CHOICE IS ----- ";
     cin>>option;
    switch(option)
    {
        case 1: cout<<"\n\nYOU HAVE CHOOSED TO OPEN A NEW ACCOUNT : "<< endl;
                newCustomer();
                pop.mainMenu1();
                option=5;

        case 2: cout<<"\n\n YOU HAVE CHOOSED TO MAKE A DRAFT"<<endl;
                pop.draft();
                break;
        case 3: cout<<"\n\nplease enter that account number "<<endl;
                cin>>num;
                deposit(num);break;
        case 4: cout<<"\n\n we are your bank and we wish for you better today and tomorrow   ";
                cout<<"\n Your agreement with us for the use of the Personal Internet";
                cout<<"\n\n Banking Service consists of:";
                cout<<"\n\n  these Personal Internet Banking Terms and Conditions and any";
                cout<<"\n additional terms and conditions we give to you relating to the";
                cout<<"\n Personal Internet Banking Service (the Terms); and";
cout<<"\n\n  any specific terms and conditions relating to your use of the";
cout<<"\n Personal Internet Banking Service that are in the terms and";
cout<<"\n conditions that apply to any specific product or service you can";
cout<<"\n access via the Personal Internet Banking Service which may be";
cout<<"\n provided before, at the same time as, or after you start using the";
cout<<"\n Personal Internet Banking Service.";
cout<<"\n In the event of a conflict between the Terms and any terms and";
cout<<"\n conditions that apply to any specific product or service you have";
cout<<"\n that you can access via the Personal Internet Banking Service";
cout<<"\n and which relate to your use of the Personal Internet Banking";
cout<<"\n Service, the Terms will apply unless the conflict relates to terms";
cout<<"\n and conditions about making payments via PIB in which case the";
cout<<"\n terms and conditions that apply to the specific product or service";
cout<<"\n that you have will apply.";
cout<<"\n We may change the Terms in accordance with clauses 9 to 11.";
cout<<"\n Unless you are using the Personal Internet Banking Service";
cout<<"\n in respect of your sole trader accounts, the Personal Internet";
cout<<"\n Banking Service should not be used for business purposes. No";
cout<<"\n third party will have any rights under the Terms. ";
cout<<"\nPlease read the Terms and keep them in a safe place.";
cout<<"\nYou can ask for a copy of the Terms at any time.";
cout<<"\n\n1. Definitions";
cout<<"\n\n1.1 you, your and yours mean the person requesting PIB.";
cout<<"\n\n1.2 we us and our mean YOUR Bank plc, and any agents we";
cout<<"\nappoint to provide all or any part of PIB.";
cout<<"\n\n1.3 YOUR Group means YOUR Holdings plc, its subsidiaries,";
cout<<"\nassociated and affiliated companies and any of their branches";
cout<<"\nand offices.";
cout<<"\n\n1.4 Personal Internet Banking Service and PIB mean the";
cout<<"\ninternet banking service provided by us to you by which you may";
cout<<"\naccess information and give instructions in respect of certain of";
cout<<"\nyour products or services. We may make additional functions";
cout<<"\navailable to you such as e-messaging or the ability to apply for";
cout<<"\nnew products or services; if we do this, we will make information";
cout<<"\nabout it available to you.";
cout<<"\n\n1.5 User Guide means the guidance and information set out in";
cout<<"\nthe User Guide or Help Centre on PIB and all other guidance";
cout<<"\nissued by us in connection with PIB, as amended from time to";
cout<<"\ntime.";
cout<<"\n\n1.6 working days mean Monday to Friday except public";
cout<<"\nholidays.";
cout<<"\n\n3. Your security details";
cout<<"\n\n3.1 You must take all reasonable precautions to keep safe";
cout<<"\nand prevent fraudulent use of your PIB security details (this";
cout<<"\nwill include your user ID, PINs, passwords and other security";
cout<<"\ninformation).";
cout<<"\n\n3.2 These precautions include, but are not limited to all of the";
cout<<"\nfollowing:";
cout<<"\n never writing down or otherwise recording your PIN and other";
cout<<"\nsecurity details in a way that can be understood by someone else;";
cout<<"\n not choosing security details that may be easy to guess;";
cout<<"\n taking care to ensure that no one hears or sees your security";
cout<<"\ndetails when you use them;";
cout<<"\n keeping your security details unique to your products with us;";
cout<<"\n not allowing anyone else to have or use your PIN or any of your";
cout<<"\nother security details and not disclosing them to anyone, including";
cout<<"\nthe police and us, except when registering for or resetting your";
cout<<"\nsecurity details (but even then do not disclose in full);";
cout<<"\n keeping information about your account containing personal";
cout<<"\ndetails (such as statements) safe and disposing of them safely.";
cout<<"\nPeople who commit fraud use many methods such as searching";
cout<<"\nin dustbins to obtain this type of information. You should take";
cout<<"\nsimple precautions such as shredding paper containing such";
cout<<"\ninformation;";
cout<<"\n changing your security details immediately and telling us as";
cout<<"\nsoon as possible if you know, or even suspect, that someone";
cout<<"\nelse knows any of those details, or if we ask you to;";
cout<<"\n keeping your PIN and other security details safe;";
cout<<"\n keep your personal computer secure by using anti-virus and";
cout<<"\nanti-spyware software and a personal firewall;";
cout<<"\n keep your passwords and PINs and other security details";
cout<<"\nsecret  we will never ask you for your online banking security";
cout<<"\ninformation in full;";
cout<<"\n never go to an internet banking site from a link in an email and";
cout<<"\nthen enter personal details, always access PIB by typing in the";
cout<<"\nbank address to your web browser;";
cout<<"\n never access PIB from any computer connected to a local area";
cout<<"\nnetwork (LAN) (this is usually the case for computers you use";
cout<<"\nat work) or any public internet access device or access point";
cout<<"\n(for example, at an internet cafe) without first making sure that";
cout<<"\nno one else will be able to observe or copy your access or get";
cout<<"\naccess to PIB by pretending to be you;";
cout<<"\n never record any password or other security details on any";
cout<<"\nsoftware which retains it automatically (for example, any";
cout<<"\ncomputer screen prompts or save password feature or the";
cout<<"\nline on your internet browser) unless retaining your password";
cout<<"\nor security details is a specific function of a banking service";
cout<<"\nprovided by us;";
cout<<"\n once you have logged on to PIB, do not leave the device from";
cout<<"\nwhich you have accessed it or let anyone else use that device";
cout<<"\nuntil you have logged off; and";
break;
        case 5:break;
               // cin>>
    }
}
while(option!=5);
}

void shortbank::mainMenu1()
{
    shortbank pop;
    int pay;
    int accno;
    int option;
    int num;
    int rnum;
    int password;
    int choose;
    char name[20];
    char bankBranch[30];
    do
    {
     cout<<"\n\n\tPlease select any one of the following options (1-8):";
     cout<<"\n\n\t1...withdrawl money.";
     cout<<"\n\n\t2...deposit money.";
     cout<<"\n\n\t3...balance enquiry.";
     cout<<"\n\n\t4...print passbook.";
     cout<<"\n\n\t5...change password.";
     cout<<"\n\n\t6...delete account.";
     cout<<"\n\n\t7...edit details.";
     cout<<"\n\n\t8...money transfer.";
     cout<<"\n\n\t9...draft/cheque/PO.";
     cout<<"\n\n\t0...exit.";

     cout<<"\nYOUR CHOICE IS ----- ";
     cin>>option;
    switch(option)
    {
        case 1: cout<<"\n\nplease enter your account number : ";
                cin>>num;
                withdrawl(num);continue;
        case 2: cout<<"\n\nplease enter your account number : ";
                cin>>num;
                deposit(num);continue;
        case 3: cout<<"\n\nplease enter your account number :     ";
                cin>>num;
                cout<<"\n\nplease enter your password       :     ";
                cin>>password;
                details(num,password);continue;
        case 4: cout<<"\n\nplease enter your account number  :    ";
                cin>>num;
                printpassbook(num);
                continue;
        case 5: cout<<"\n\nCHANGE PASSWORD";
                cout<<"\nenter your account number  :     ";
                cin>>num;
                changePass(num);
                cout<<"\n\n TO CONTINUE,AGAIN LOG IN ";
                option=8;
                continue;
        case 6: cout<<"\n\nDELETE ACCOUNT ";
                cout<<"\nenter your account number :";
                cin>>num;
                deletecu(num);continue;
        case 7: cout<<"\n\nEDIT YOUR DETAILS :  ";
                cout<<"\nenter your account number  :     ";
                cin>>num;
                editdetails(num);
                continue;
        case 8: cout<<"\n\nMONEY TRANSFER    ";
                cout<<"\nenter your account number  :     ";
                cin>>num;
                cout<<"\npress 1 for same bank account and 2 for other bank account  :  ";
                cin>>choose;
                if(choose==1)
                       {
                        cout<<"\nenter account number of recipient :  ";
                        cin>>rnum;
                        cout<<"\nenter name of account holder      :  ";
                        cin.ignore();
                        cin.getline(name,20);
                        sameBankTransfer(num,rnum);
                        cout<<"\n\nMoney is deposited in account number "<<rnum<<" of "<<name;
                       }
                else
                      if(choose==2)
                       {
                           cout<<"\nEnter the name of bank : ";
                           cin.ignore();
                           cin.getline(bankBranch,25);
                           cout<<"\nenter name of account holder      :  ";
                           cin.ignore();
                           cin.getline(name,20);
                           cout<<"\nenter account number of recipient :  ";
                           cin>>rnum;
                           otherBank(num,rnum);
                           cout<<"\n\nMoney is deposited in account number "<<rnum<<" of "<<name;

                }
                continue;
        case 9: cout<<"\nMAKE DRAFT....";
                cout<<"\nPress 1 to make payment from self account or 2 for hard cash";
                cin>>pay;
                       if(pay==2)
                       {
                           pop.draft();continue;
                       }
                       else
                        if(pay==1)
                       {
                          cout<<"\nEnter Your Account Number";
                          cin>>accno;
                          pop.selfdraft(accno);break;
                       }
                       continue;
        case 0:break;
               // cin>>
    }
}while(option!=0);
}
void shortbank::mainMenuadmin()
{
    //shortbank pop;
    int option;
    int p1;
    int num,password,rnum;
    char nameR[15];
    do
    {
     cout<<"\n\n\tPlease select any one of the following options (1-10):";
     cout<<"\n\n\t1....Open a new account.";
     cout<<"\n\n\t2....Details of account holder.";//this can only be used by an employeee//
     cout<<"\n\n\t3....Withdrawl money.";
     cout<<"\n\n\t4....Deposit money.";
     cout<<"\n\n\t5....Balance enquiry.";
     cout<<"\n\n\t6....Print passbook.";
     cout<<"\n\n\t7....Delete account.";//this can only be operated by an employee//
     cout<<"\n\n\t8....Edit details.";//this can only be opereated by an employee//
     cout<<"\n\n\t9....Money transfer.";
     cout<<"\n\n\t10...Other Bank Transfer.";
     cout<<"\n\n\t11...All Account Holders List.";
     cout<<"\n\n\t0....EXIT.";
     cout<<"\nYOUR CHOICE IS ----- ";
     cin>>option;


  switch(option)
    {
        case 1: cout<<"\n\nyou have choosed to open a new account";
                newCustomer();break;
        case 2: cout<<"\n\nplease enter the account number of the customer--";
                cin>>num;
                cout<<"\n\nplease ask him/her to enter the password       --";
                cin>>password;
                details(num,password);break;
        case 3: cout<<"\n\nyou have choosed to withdrawal money from customer's account";
                cout<<"\nEnter the account number--";
                cin>>num;
                withdrawl(num);continue;
        case 4: cout<<"\n\nyou have choosed to deposit money in customer's account";
                cout<<"\nenter account number\n\n";
                cin>>num;
                deposit(num);continue;
        case 5: cout<<"\n\nyou have choosed the option to get customer's balance";
                cout<<"\nEnter customer's Account Number --";
                cin>>num;
                cout<<"\nAsk him to enter the Password--";
                cin>>p1;
                detailshort(num,p1);continue;
        case 6: cout<<"\n\nyou have choosed the option to print customer's passbook";
                cout<<"\nenter account number\n\n";
                cin>>num;
                printpassbook(num);continue;
        case 7: cout<<"\n\nyou have choosed the option to delete the customer's account";

                cout<<"\nenter account number\n\n";
                cin>>num;
                deletecu(num);continue;
                //deletecu(num);continue;
        case 8: cout<<"\n\nyou have choosed the option to edit the customer's details";
                cout<<"\nenter account number\n\n";
                cin>>num;
                editdetails(num);continue;
        case 9: cout<<"\n\nyou have choosed to transfer money from customer's account";
                cout<<"\nEnter custorme's  A/C no. ";cin>>num;
                cout<<"\nEnter receipent's A/C no. ";cin>>rnum;
                cout<<"\nEnter name of receipent   ";
                cin.ignore();
                cin.getline(nameR,15);
                sameBankTransfer(num,rnum);
                cout<<"\n\nMoney is deposited in account number "<<rnum<<" of "<<nameR;
                continue;
        case 10: cout<<"\n\nyou have choosed for other bank transfer : ";
                cout<<"\nEnter custorme's  A/C no. ";cin>>num;
                cout<<"\nEnter receipent's A/C no. ";cin>>rnum;
                cout<<"\nEnter name of receipent   ";cin.ignore();cin.getline(nameR,15);
                otherBank(num,rnum);
                cout<<"\n\nMoney is deposited in account number "<<rnum<<" of "<<nameR;
                continue;
        case 11:cout<<"\nAccount Holder's of Your Bank";
                customerlist();
                continue;
        case 0:break;


    }continue;
}
while(option!=0);
}

void shortbank::reg_staff()
{
    cout<<"\nENTER YOUR NAME                      :-- ";
    cin.ignore();
    cin.getline(nameS,30);
    cout<<"\nENTER UNIQUE ID (4 DIGIT INTEGER)    :-- ";
    cin>> idEmp;
}
void shortbank::creat_acc()
{
    int i=0;
    int y;
    int curdob;
    int m;
    int d;
   //cout<<"\n\nENTER YOUR ACCOUNT NUMBER :";
   // shortbank.agf()
   //
 // cin>>accountNumber;
    cout<<"\n\n ENTER YOUR NAME                                 :--";
    cin.ignore();
    cin.getline(nameOfAccountHolder,30);
    cout<<"\n\n ENTER YOUR PARENT/HUSBAND NAME                  :--";
    cin.ignore();
    cin.getline(parentName,30);
    cout<<"\n\n ENTER YOUR GENDER                               :--";
    cin.ignore();
    cin.getline(sex,10);
do
    {
    cout<<"\n\n ENTER YOUR DOB(DDMMYYYY format)                 :--";
    cin>>dob;
     y=dob%10000;
     curdob=dob/10000;
     m=curdob%100;
     d=curdob/100;
    if((y<1950||y>2013)||(m<1||m>12)||(d<1||d>31))
    {
        cout<<"\ninvalid date of birth";continue;
    }
    else break;
    }
    while(!((y<1950||y>2013)||(m<1||m>12)||(d<1||d>31)));
    cout<<"\n\n ENTER YOUR TEMPERORY ADDRESS                    :--";
    cin.ignore();
    cin.getline(tempadd,50);
    cout<<"\n\n ENTER YOUR PERMANENT ADDRESS                    :--";
    cin.ignore();
    cin.getline(permadd,50);
    do
    {
    cout<<"\n\n ENTER YOUR CONTACT NUMBER(10digit)              :--";
    cin>>mobileNo;
    if(mobileNo<6000000000||mobileNo>9999999999)
    {
        cout<<"\nInvalid Mobile Number!!";continue;
    }
    else
        break;
    }
    while(!(mobileNo<1000000000||mobileNo>9999999999));
    cout<<"\n\n WHICH ID YOU WANT TO SUBMIT                     :--";
    cin.ignore();
    cin.getline(id,20);
    cout<<"\n\n ENTER YOUR ID SERIAL NUMBER(only numeric)       :--";
    cin>>idno;
    do
    {
    cout<<"\n\n Account type current or savings(c or s)         :--";
    cin>>accountType;
       if(accountType=='c'||accountType=='C'||accountType=='s'||accountType=='S')
         break;
       else
         continue;
    }
    while(!(accountType=='c'||accountType=='C'||accountType=='s'||accountType=='S'));
   int counting=0;
    do
    {
    cout<<"\n\n INITIAL DEPOSIT(SAVING=Rs 1000,CURRENT=Rs 2000)  Rs.";
    cin>>bal;
        if((accountType=='s'&& bal>=1000)||(accountType=='S'&& bal>=1000))
            break;
        else
            if((accountType=='c'&& bal>=2000)||(accountType=='C'&& bal>=2000))
            break;
        else continue;
        counting++;
    }
    while(true);

   do
   {
    cout<<"\n\n ENTER YOUR PASSWORD   (4 digit numeric)          :--";
    cin>>pass;
    cout<<"\n\n CONFIRM YOUR PASSWORD (4 digit numeric)          :--";
    cin>>pass1;
    if(pass==pass1)
    {

        accountNumber=generateacc();
        cout<<"\n YOUR ACCOUNT NUMBER IS  "<<accountNumber<<"  REMEMBER IT FOR FUTRUE REFRENCE";
        cout<<"\n ACCOUNT CREATED"<<"\nHAVE A NICE DAY";break;
    }
     else
        {
        cout<<"\n PASSWORD DOES NOT MATCH";
        }continue;

      i++;
   }
   while(pass!=pass1);

}
void shortbank::showNameBalance()const
{
    cout<<"\n\n****************************************************************";
cout<<"\n Acc.No"<<setw(7)<<" "<<"Name of account holder"<<setw(5)<<" "<<"balance"<<setw(10)<<"type"<<endl;
        cout<<"________________________________________________________________";
   cout<<"\n "<<accountNumber<<setw(8)<<" "<<nameOfAccountHolder<<setw(14)<<" "<<bal<<setw(9)<<accountType<<endl;
 //  cout<<"\n\nAccount Number     ";cout<<"Name                 ";cout<<"       Available balance  : ";
 //  cout<<"\n"<<accountNumber<<"\t\t   "<<nameOfAccountHolder<<"\t\t\t"<<bal;

}

void shortbank::show_staff()const
{
    cout<<"\n\nName                : "<<nameS;
    cout<<"\n\nId                  : "<<idEmp;

}

void shortbank::allaccounts() const
{
	cout<<"  "<<accountNumber<<setw(8)<<accountType<<setw(14)<<bal<<"       "<<nameOfAccountHolder<<"         "<<tempadd<<endl;
}


 void shortbank::show_details() const
   {

    cout<<"\n\nAccount No.       : "<<accountNumber;
    cout<<"\nAccount type        : "<<accountType;
	cout<<"\nAccount Holder Name : "<<nameOfAccountHolder;
	cout<<"\nParent name         : "<<parentName;
	cout<<"\nYour Sex            : "<<sex;
	cout<<"\nDate of birth       : "<<dob;
	cout<<"\nPermanent Address   : "<<permadd;
	cout<<"\nTemperory Adress    : "<<tempadd;
	cout<<"\nContact no.         : "<<mobileNo;
	cout<<"\nYou have submitted  : "<<id<<"    as your ID,whose number is "<<idno;
    cout<<"\nBalance amount      : "<<bal;
	//cout<<"\n\nPassword            :"<<pass;
   }

int shortbank::returnbal()const
{
    return bal;
    //cout<<"\n\n\t all ok";
}

int shortbank::return_id()const
{
    return idEmp;
}
int shortbank::returnacc()const
{
   //  cout<<"\n\n\n"<<accountNumber<<"\n";
    return accountNumber;

}

int shortbank::returnpass()const
{
    return pass;

}

void shortbank::changepassword(int p)
{

                pass=p;


}

void shortbank::depositIt(int x)
{
	bal=bal+x;
}

void shortbank::withdrawIt(int x)
{
	bal=bal-x;
}

char shortbank::returntype()const
{
	return accountType;
}

void shortbank::selfdraft(int q)
{
    shortbank pop;
     int dateOfDraft,amtOfDraft;
    char draftInFavourOf[50];
    char sigMan[15];
                cout<<"\ntodays date(ddmmyyyy)--";
                cin>>dateOfDraft;
                cout<<"\ndraft in favour of ----";
                cin.ignore();
                cin.getline(draftInFavourOf,50);
                cout<<"\namount of draft--------";
                cin>>amtOfDraft;
                make_own_draft(q,amtOfDraft);
                cout<<"\nsignature of manager---";
                cin.ignore();
                cin.getline(sigMan,15);
                cout<<"\n\n----------------------------------------------------------------------";
                cout<<"\n\t\t\t\t YOUR BANK "<<endl;
                cout<<"\t\t\t\t\t\t\tdate-"<<dateOfDraft;
                cout<<"\ndraft in favour of--- Mr/Mrs/Miss "<<draftInFavourOf;
                cout<<"\n\t\t\t\t\t  amount--Rs."<<amtOfDraft;
                cout<<"\n\nSerial No."<<pop.generateacc()<<"\t\t\t\t\t( "<<sigMan<<" )";
                cout<<"\n"<<nameOfAccountHolder<<"\t\t\t\tManager";
                cout<<"\n\n----------------------------------------------------------------------";

}

void regStaff()                                                                  //for employee registration//
{
    shortbank pop;
    ofstream writeinfile;
	writeinfile.open("quartz.txt",ios::binary|ios::app);
    pop.reg_staff();                                                        //calling registration of new staff//
	writeinfile.write(reinterpret_cast<char *> (&pop), sizeof(shortbank));
	writeinfile.close();
}

void newCustomer()
{
	shortbank pop;

	ofstream writeinfile;
	writeinfile.open("rutile.dat",ios::binary|ios::app);
    pop.creat_acc();
	writeinfile.write(reinterpret_cast<char *> (&pop), sizeof(shortbank));
	writeinfile.close();
	//cout<<"\n\n\t all ok";

}


void details(int n,int p)
{
    shortbank pop;
	bool flag=false;
	ifstream inFile;
	inFile.open("rutile.dat",ios::binary);
	if(!inFile)
	{
		cout<<"File could not be open !! Press any Key...";
		return ;
	}
cout<<"\nYOUR ACCOUNT DETAILS\n";
    	while(inFile.read(reinterpret_cast<char *> (&pop), sizeof(shortbank)))
	{
	   // cout<<"\n\n\t all ok";
		if(pop.returnacc()==n&&pop.returnpass()==p)
           {
            pop.show_details();
			flag=true;break;

		}
	}
        inFile.close();
	    if(flag==false)
		cout<<"\n\nAccount number does not exist";
}

int login(int me)
{
    shortbank pop;
    bool exam=false;
    ifstream kholo;
    kholo.open("quartz.txt",ios::binary);
    if(!kholo)
    {
      cout<<"\n bad signal";
      return -1;
    }
    while(kholo.read(reinterpret_cast<char *>(&pop),sizeof(shortbank)))
    {
        if(pop.return_id()==me)
        {pop.show_staff();
        exam=true;return 1;
        }
    }kholo.close();
    if(exam==false)
		cout<<"\n\nNo Record Found !!!!!";
return 0;

}

  int detailshort(int an,int pd)
  {
      shortbank pop;
      bool flag=false;
	ifstream sopen;
	sopen.open("rutile.dat",ios::binary);
	if(!sopen)
	{
		cout<<"File could not be open !! Press any Key...";
		return -1;
	}

    	while(sopen.read(reinterpret_cast<char *> (&pop), sizeof(shortbank)))
	{
		if(pop.returnacc()==an&&pop.returnpass()==pd)
           {
               cout<<"\nINTRODUCING YOUR DETAILS\n\n";
          /*    cout<<"********************************************************************\n";
	          cout<<"A/c no.      NAME                      Balance        type"<<endl;
	          cout<<"--------------------------------------------------------------------\n";*/
            pop.showNameBalance();
			flag=true;
return 1;
		}
	}
        sopen.close();
	    if(flag==false)
		cout<<"\n\nNo Record Found !!!!!";
return 0;
  }

void deposit(int acc)
{
	int depo;int b;
	bool found=false;
	shortbank pop;
	fstream subIt;
	subIt.open("rutile.dat", ios::binary|ios::in|ios::out);
	if(!subIt)
	{
		cout<<"File could not be open !! Press any Key...";
		return;
	}
	while(!subIt.eof() && found==false)
	{
		subIt.read(reinterpret_cast<char *> (&pop), sizeof(shortbank));
		if(pop.returnacc()==acc)
		{
		    /* cout<<"*********************************************************************\n";
	          cout<<"A/c no.      NAME                   Balance      type\n";
	          cout<<"--------------------------------------------------------------------\n";*/
			pop.showNameBalance();


				cout<<"\n\n\tTO DEPOSITE AMOUNT ";
				cout<<"\n\nEnter The amount of money, Rs. ";
				cin>>depo;
				pop.depositIt(depo);


			int pos=(-1)*static_cast<int>(sizeof(pop));
			subIt.seekp(pos,ios::cur);
			subIt.write(reinterpret_cast<char *> (&pop), sizeof(shortbank));
			b=pop.returnbal();
			cout<<"\n\nCURRENT BALANCE IS Rs. "<<b;
			found=true;
	       }
         }
	subIt.close();
	if(found==false)
		cout<<"\n\n Record Not Found ";
}

void make_own_draft(int ac,int am)
{

	int rbal;
	int curbal;
	shortbank pop;
	bool found=false;
	fstream addup;
	addup.open("rutile.dat", ios::binary|ios::in|ios::out);
	if(!addup)
	{
		cout<<"File could not be open !! Press any Key...";
		return;
	}
	while(!addup.eof() && found==false)
	{
		addup.read(reinterpret_cast<char *> (&pop), sizeof(shortbank));
		if(pop.returnacc()==ac)
		{
			cout<<"\n";
			 /*cout<<"***********************************************************************\n";
	          cout<<"A/c no.      NAME                   Balance        type\n";
	          cout<<"----------------------------------------------------------------------\n";*/
			//pop.showNameBalance();


			{

				//cout<<"\n\n\tTO WITHDRAW MONEY ";
				//cout<<"\n\nEnter The amount to be withdrawn--- Rs.";
				//cin>>with;
				rbal=pop.returnbal();
				curbal=rbal-am;//cout<<"\n\n\t\t"<<curbal;
				if (curbal<1000 && pop.returntype()=='S')
					{
					    cout<<"AMOUNT INSUFFICIENT !!!!!";
					}
					else if(curbal<1000 && pop.returntype()=='s')
                    {
                         cout<<"AMOUNT INSUFFICIENT !!!!!";
                    }
					else if  (curbal<2000 && pop.returntype()=='C')
			    	{
					    cout<<"AMOUNT INSUFFICIENT !!!!!";
					}
					else if (curbal<2000 && pop.returntype()=='c')
                    {
                        cout<<"AMOUNT INSUFFICIENT !!!!!";
                    }
				else
					{
					    pop.withdrawIt(am);
					}
			}
			int pos=(-1)*static_cast<int>(sizeof(pop));
			addup.seekp(pos,ios::cur);
			addup.write(reinterpret_cast<char *> (&pop), sizeof(shortbank));
           // ii=pop.returnbal();
			//cout<<"\n\nAVAILABLE BALANCE IS  Rs. "<<ii;
			found=true;
	       }
         }
    addup.close();
	if(found==false)
		cout<<"\n\n Record Not Found ";
}

void withdrawl(int ac)
{
	int with;
	int ii;
	int curbal;
	shortbank pop;
	bool found=false;
	fstream addup;
	addup.open("rutile.dat", ios::binary|ios::in|ios::out);
	if(!addup)
	{
		cout<<"File could not be open !! Press any Key...";
		return;
	}
	while(!addup.eof() && found==false)
	{
		addup.read(reinterpret_cast<char *> (&pop), sizeof(shortbank));
		if(pop.returnacc()==ac)
		{
			cout<<"\n";
			 /*cout<<"***********************************************************************\n";
	          cout<<"A/c no.      NAME                   Balance        type\n";
	          cout<<"----------------------------------------------------------------------\n";*/
			pop.showNameBalance();


			{

				cout<<"\n\n\tTO WITHDRAW MONEY ";
				cout<<"\n\nEnter The amount to be withdrawn--- Rs.";
				cin>>with;
				curbal=(pop.returnbal()-with);//cout<<"\n\n\t\t"<<curbal;
				if (curbal<1000 && pop.returntype()=='S')
					{
					    cout<<"AMOUNT INSUFFICIENT !!!!!";
					}
					else if(curbal<1000 && pop.returntype()=='s')
                    {
                         cout<<"AMOUNT INSUFFICIENT !!!!!";
                    }
					else if  (curbal<2000 && pop.returntype()=='C')
			    	{
					    cout<<"AMOUNT INSUFFICIENT !!!!!";
					}
					else if (curbal<2000 && pop.returntype()=='c')
                    {
                        cout<<"AMOUNT INSUFFICIENT !!!!!";
                    }
				else
					{
					    pop.withdrawIt(with);
					}
			}
			int pos=(-1)*static_cast<int>(sizeof(pop));
			addup.seekp(pos,ios::cur);
			addup.write(reinterpret_cast<char *> (&pop), sizeof(shortbank));
            ii=pop.returnbal();
			cout<<"\n\nAVAILABLE BALANCE IS  Rs. "<<ii;
			found=true;
	       }
         }
    addup.close();
	if(found==false)
		cout<<"\n\n Record Not Found ";
}

void printpassbook(int n)
{
	shortbank pop;
	bool flag=false;
	ifstream printpass;
	printpass.open("rutile.dat",ios::binary);
	if(!printpass)
	{
		cout<<"File could not be open !! Press any Key...";
		return;
	}
	cout<<"\nPRINTING PASSBOOK\n";
    	while(printpass.read(reinterpret_cast<char *> (&pop), sizeof(shortbank)))
	{
		if(pop.returnacc()==n)
		{
		 /*   cout<<"****************************************************************\n";
	        cout<<"A/c no.      NAME           Balance       type\n";
	        cout<<"----------------------------------------------------------------\n";*/
			pop.showNameBalance();
			flag=true;
		}
	}
    printpass.close();
	if(flag==false)
		cout<<"\n\nAccount number does not exist";
}

void changePass(int n)
{
    shortbank pop;
   // int cp;
    int opass;
    int npass;
    int npass2;
    bool flag=false;

    fstream changepass;
    //ofstream wchangepass;
    changepass.open("rutile.dat",ios::binary|ios::in|ios::out);
    if(!changepass)
        {
		cout<<"File could not be open !! Press any Key...";
		return;
	}
	while(!changepass.eof() && flag==false)
	{
		changepass.read(reinterpret_cast<char *> (&pop), sizeof(shortbank));
		if(pop.returnacc()==n)
		{
		   cout<<"\n";
		/*    cout<<"********************************************************************\n";
	          cout<<"A/c no.      NAME                   Balance       type\n";
	          cout<<"------------------------------------------------------------------\n";*/
		    pop.showNameBalance();
			cout<<"\nplease enter your old password";
			cin>>opass;
			if(pop.returnpass()==opass)
            {

               do
               {
                cout<<"\nenter your new password----";
                cin>>npass;
                cout<<"\nconfirm your password  ----";
                cin>>npass2;
                if(npass==npass2)
                    break;
                else
                    continue;
               }while(npass!=npass2);
                pop.changepassword(npass2);
            }
			int pos=(-1)*static_cast<int>(sizeof(shortbank));
            changepass.seekp(pos,ios::cur);
			changepass.write(reinterpret_cast<char *> (&pop), sizeof(shortbank));
			cout<<"\npassword successfully changed";
           flag=true;
	       }
         }
    changepass.close();
	if(flag==false)
		cout<<"\n\n Record Not Found ";

}

void editdetails(int no)
{
    bool status=false;
	shortbank pop;
	fstream modi;
    modi.open("rutile.dat",ios::binary|ios::in|ios::out);
	if(!modi)
	{
		cout<<"File could not be open !! Press any Key...";
		return;
	}
	while(!modi.eof() && status==false)
	{
		modi.read(reinterpret_cast<char *> (&pop), sizeof(shortbank));
		if(pop.returnacc()==no)
		{
			pop.show_details();
			cout<<"\n\nEDIT DETAILS"<<endl;
			pop.modifyDetails();
			int pos=(-1)*static_cast<int>(sizeof(shortbank));
			modi.seekp(pos,ios::cur);
		    modi.write(reinterpret_cast<char *> (&pop), sizeof(shortbank));
		    cout<<"\n\n\t Record Updated";
		    status=true;
		  }
	}
	modi.close();
	if(status==false)
		cout<<"\n\n Record Not Found ";
}


void otherBank(int own,int other)
{
    int with;
	int ii;
	int curbal;
	shortbank pop;
	bool found=false;
	fstream addup;
	addup.open("rutile.dat", ios::binary|ios::in|ios::out);
	if(!addup)
	{
		cout<<"File could not be open !! Press any Key...";
		return;
	}
	while(!addup.eof() && found==false)
	{
		addup.read(reinterpret_cast<char *> (&pop), sizeof(shortbank));
		if(pop.returnacc()==own)
		{
			cout<<"\nYOUR DETAILS"<<endl;
			/* cout<<"***************************************************************\n";
	          cout<<"A/c no.      NAME                   Balance      type\n";
	          cout<<"---------------------------------------------------------------\n";*/
			pop.showNameBalance();


			{
				//cout<<"\n\n\tTO TRANSFER MONEY ";
				cout<<"\n\nEnter The amount to be transfered---Rs. ";
				cin>>with;
				curbal=pop.returnbal()-with;
				if ((curbal<1000 && pop.returntype()=='S')||(curbal<1000 && pop.returntype()=='s') || (curbal<2000 && pop.returntype()=='C') ||(curbal<2000 && pop.returntype()=='c'))
					cout<<"AMOUNT INSUFFICIENT !!!!!";
				else
					pop.withdrawIt(with);
			}
			int pos=(-1)*static_cast<int>(sizeof(pop));
			addup.seekp(pos,ios::cur);
			addup.write(reinterpret_cast<char *> (&pop), sizeof(shortbank));
            ii=pop.returnbal();
			cout<<"\n\nAVAILABLE BALANCE IS  Rs. "<<ii;
			found=true;
	       }
         }
    addup.close();
	if(found==false)
		cout<<"\n\n Record Not Found ";
}


void sameBankTransfer(int num,int rnum)
{
 int with;
	//int ii;
	int curbal;
	shortbank pop;
	bool found=false;
	fstream addup;
	addup.open("rutile.dat", ios::binary|ios::in|ios::out);
	if(!addup)
	{
		cout<<"File could not be open !! Press any Key...";
		return;
	}
	while(!addup.eof() && found==false)
	{
		addup.read(reinterpret_cast<char *> (&pop), sizeof(shortbank));
		if(pop.returnacc()==num)
		{
			//pop.showNameBalance();


			{
				//cout<<"\n\n\tTO TRANSFER AMOUNT ";
				cout<<"\n\nEnter The amount to be transfered--- Rs.";
				cin>>with;
				curbal=pop.returnbal()-with;//cout<<"\n\n\t\t"<<curbal;
				if ((curbal<1000 && pop.returntype()=='S')||(curbal<1000 && pop.returntype()=='s') || (curbal<2000 && pop.returntype()=='C') ||(curbal<2000 && pop.returntype()=='c'))
					{
					    cout<<"AMOUNT INSUFFICIENT !!!!!";
					}
				else
					{
					    pop.withdrawIt(with);
					}
			}
			int pos=(-1)*static_cast<int>(sizeof(pop));
			addup.seekp(pos,ios::cur);
			addup.write(reinterpret_cast<char *> (&pop), sizeof(shortbank));
        //   int ii=pop.returnbal();

    {

    //int b;
	bool found=false;
	shortbank pop;
	fstream subIt;
	subIt.open("rutile.dat", ios::binary|ios::in|ios::out);
	if(!subIt)
	{
		cout<<"File could not be open !! Press any Key...";
		return;
	}
	while(!subIt.eof() && found==false)
	{
		subIt.read(reinterpret_cast<char *> (&pop), sizeof(shortbank));
		if(pop.returnacc()==rnum)
		{
			pop.depositIt(with);
			cout<<"\ndetails of recipient "<<endl;
			/* cout<<"*********************************************************************\n";
	          cout<<"A/c no.      NAME                       Balance        type\n";
	          cout<<"--------------------------------------------------------------------\n";*/
			pop.showNameBalance();


				//cout<<"\n\n\tTO DEPOSITE AMOUNT ";
				//cout<<"\n\nEnter The amount to be deposited  Rs. ";
				//cin>>depo;



			int pos=(-1)*static_cast<int>(sizeof(pop));
			subIt.seekp(pos,ios::cur);
			subIt.write(reinterpret_cast<char *> (&pop), sizeof(shortbank));
		//	b=pop.returnbal();
		//	cout<<"\n\nCURRENT BALANCE IS Rs. "<<b;
			found=true;
	       }
         }
	subIt.close();
	if(found==false)
		cout<<"\n\n Record Not Found ";
		}

			//cout<<"\n\nAVAILABLE BALANCE IN YOUR ACCOUNT IS Rs. "<<ii;
			found=true;
	       }
         }
    addup.close();
	if(found==false)
		cout<<"\n\n Record Not Found ";
}

void deletecu(int no)

{
	shortbank pop;
	ifstream kholoji;
	ofstream bhejoji;
	kholoji.open("rutile.dat",ios::binary);
	if(!kholoji)
	{
		cout<<"File could not be open !! Press any Key...";
		return;
	}
	bhejoji.open("Tempo.txt",ios::binary);
	kholoji.seekg(0,ios::beg);
	while(kholoji.read(reinterpret_cast<char *> (&pop), sizeof(shortbank)))
	{
		if(pop.returnacc()!=no)
		{
			bhejoji.write(reinterpret_cast<char *> (&pop), sizeof(shortbank));
		}
	}
    kholoji.close();
	bhejoji.close();
	remove("rutile.dat");
	rename("Tempo.txt","rutile.dat");
	cout<<"\n\n\tRecord Deleted ..";
}


void customerlist()
{
	shortbank pop;
	ifstream openit;
	openit.open("rutile.dat",ios::binary);
	if(!openit)
	{
		cout<<"File could not be open !! Press any Key...";
		return;
	}
	cout<<"\n\n\t\tLIST OF ALL CUSTOMERS\n\n";
	cout<<"_______________________________________________________________________________\n";
	cout<<"  A/C NO.     TYPE      BALANCE       NAME                    ADDRESS \n";
	cout<<"_______________________________________________________________________________\n";
	while(openit.read(reinterpret_cast<char *> (&pop), sizeof(shortbank)))
	{
		pop.allaccounts();
	}
	openit.close();
}
